﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace ValueUpdateTest
{
    class Program
    {
        ~Program()
        {
            Console.WriteLine("Finalize : {0}", _seed);
        }

        private int _seed = 10;

        static void Main(string[] args)
        {
            Console.WriteLine("Start Count!");
         
            var p = new Program();
            
            var t1 = new Thread(PrintType1);
            t1.Start(p);
            
            Thread.Sleep(10);

            Console.WriteLine("P._seed-1 {0}", p._seed);

            p._seed = 0;

            Console.WriteLine("P._seed-2 {0}", p._seed);
            Console.ReadLine();
        }

        private static void PrintType1(object o)
        {
            var p = (Program)o;

            for (int i = 0; i < 100000000; i++)
            {
                p._seed++;
            }

            Console.WriteLine("t1 : {0}", p._seed);
        }
    }
}
